package sll;

public class ListUtilities {
	public ListNode removeNthFromEnd(ListNode head, int n) {
		/*
		 * Step 1: Calculate the size of the chain of nodes starting from `head`.
		 * (Linear-time operation)
		 */
		int size = 0;
		ListNode current = head;
		while(current != null) {
			size ++;
			current = current.next;
		}
		
		/*
		 * Step 2: Calculate the index of the node `prev` prior to the node to be removed.
		 * (Constant-time operation)
		 */
		int indexOfPrev = size - n - 1;
		
		/*
		 * Step 3: Traverse to the `prev` node and delete its next node.
		 * (Linear-time operation)
		 */
		if(indexOfPrev < 0) { /* the node to remove is the current head */
			ListNode oldHead = head;
			head = head.next;
			oldHead.next = null;
		}
		else {
			ListNode prev = null;
			int i = 0; /* current index */
			current = head;
			while(i <= indexOfPrev) { /* i < indexOfPrev instead will ultimately let prev point to the node two links before the node to remove */
				prev = current;
				current = current.next;
				i ++;
			}
			// Exiting the loop means that `prev` is pointing to the node at index (size - n - 1)
			ListNode nodeToRemove = prev.next;
			prev.next = nodeToRemove.next;
			nodeToRemove.next = null;
		}
		
		return head;
	}
}









